JUCE: ListBox Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
ListBox Class Reference
juce_gui_basics » widgets

A list of items that can be scrolled vertically. More...

`#include <juce_ListBox.h>`

Inheritance diagram for ListBox:

## Public Types
enum | ColourIds { backgroundColourId = 0x1002800 , outlineColourId = 0x1002810 , textColourId = 0x1002820 }
| A set of colour IDs to use to change the colour of various aspects of the label. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions
| ListBox (const String &componentName=String(), ListBoxModel *model=nullptr)
| Creates a ListBox.
| ~ListBox () override
| Destructor.
void | setModel (ListBoxModel *newModel)
| Changes the current data model to display.
ListBoxModel * | getListBoxModel () const noexcept
| Returns the current list model.
void | updateContent ()
| Causes the list to refresh its content.
void | setMultipleSelectionEnabled (bool shouldBeEnabled) noexcept
| Turns on multiple-selection of rows.
void | setClickingTogglesRowSelection (bool flipRowSelection) noexcept
| If enabled, this makes the listbox flip the selection status of each row that the user clicks, without affecting other selected rows.
void | setRowSelectedOnMouseDown (bool isSelectedOnMouseDown) noexcept
| Sets whether a row should be selected when the mouse is pressed or released.
bool | getRowSelectedOnMouseDown () const
| Gets whether a row should be selected when the mouse is pressed or released.
void | setMouseMoveSelectsRows (bool shouldSelect)
| Makes the list react to mouse moves by selecting the row that the mouse if over.
void | selectRow (int rowNumber, bool dontScrollToShowThisRow=false, bool deselectOthersFirst=true)
| Selects a row.
void | selectRangeOfRows (int firstRow, int lastRow, bool dontScrollToShowThisRange=false)
| Selects a set of rows.
void | deselectRow (int rowNumber)
| Deselects a row.
void | deselectAllRows ()
| Deselects any currently selected rows.
void | flipRowSelection (int rowNumber)
| Selects or deselects a row.
SparseSet< int > | getSelectedRows () const
| Returns a sparse set indicating the rows that are currently selected.
void | setSelectedRows (const SparseSet< int > &setOfRowsToBeSelected, NotificationType sendNotificationEventToModel=sendNotification)
| Sets the rows that should be selected, based on an explicit set of ranges.
bool | isRowSelected (int rowNumber) const
| Checks whether a row is selected.
int | getNumSelectedRows () const
| Returns the number of rows that are currently selected.
int | getSelectedRow (int index=0) const
| Returns the row number of a selected row.
int | getLastRowSelected () const
| Returns the last row that the user selected.
void | selectRowsBasedOnModifierKeys (int rowThatWasClickedOn, ModifierKeys modifiers, bool isMouseUpEvent)
| Multiply-selects rows based on the modifier keys.
void | setVerticalPosition (double newProportion)
| Scrolls the list to a particular position.
double | getVerticalPosition () const
| Returns the current vertical position as a proportion of the total.
void | scrollToEnsureRowIsOnscreen (int row)
| Scrolls if necessary to make sure that a particular row is visible.
ScrollBar & | getVerticalScrollBar () const noexcept
| Returns a reference to the vertical scrollbar.
ScrollBar & | getHorizontalScrollBar () const noexcept
| Returns a reference to the horizontal scrollbar.
int | getRowContainingPosition (int x, int y) const noexcept
| Finds the row index that contains a given x,y position.
int | getInsertionIndexForPosition (int x, int y) const noexcept
| Finds a row index that would be the most suitable place to insert a new item for a given position.
Rectangle< int > | getRowPosition (int rowNumber, bool relativeToComponentTopLeft) const noexcept
| Returns the position of one of the rows, relative to the top-left of the listbox.
Component * | getComponentForRowNumber (int rowNumber) const noexcept
| Finds the row component for a given row in the list.
int | getRowNumberOfComponent (const Component *rowComponent) const noexcept
| Returns the row number that the given component represents.
int | getVisibleRowWidth () const noexcept
| Returns the width of a row (which may be less than the width of this component if there's a scrollbar).
void | setRowHeight (int newHeight)
| Sets the height of each row in the list.
int | getRowHeight () const noexcept
| Returns the height of a row in the list.
int | getNumRowsOnScreen () const noexcept
| Returns the number of rows actually visible.
void | setOutlineThickness (int outlineThickness)
| Sets the thickness of a border that will be drawn around the box.
int | getOutlineThickness () const noexcept
| Returns the thickness of outline that will be drawn around the listbox.
void | setHeaderComponent (std::unique_ptr< Component > newHeaderComponent)
| Sets a component that the list should use as a header.
Component * | getHeaderComponent () const noexcept
| Returns whatever header component was set with setHeaderComponent().
void | setMinimumContentWidth (int newMinimumWidth)
| Changes the width of the rows in the list.
int | getVisibleContentWidth () const noexcept
| Returns the space currently available for the row items, taking into account borders, scrollbars, etc.
void | repaintRow (int rowNumber) noexcept
| Repaints one of the rows.
virtual ScaledImage | createSnapshotOfRows (const SparseSet< int > &rows, int &x, int &y)
| This fairly obscure method creates an image that shows the row components specified in rows (for example, these could be the currently selected row components).
Viewport * | getViewport () const noexcept
| Returns the viewport that this ListBox uses.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
bool | keyStateChanged (bool isKeyDown) override
| Called when a key is pressed or released.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | paintOverChildren (Graphics &) override
| Components can override this method to draw over the top of their children.
void | resized () override
| Called when this component's size has been changed.
void | visibilityChanged () override
| Called when this component's visibility changes.
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
| Called when the mouse-wheel is moved.
void | mouseUp (const MouseEvent &) override
| Called when a mouse button is released.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
void | startDragAndDrop (const MouseEvent &, const SparseSet< int > &rowsToDrag, const var &dragDescription, bool allowDraggingToOtherWindows)
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
ListBoxModel * | getModel () const noexcept
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.
Protected Member Functions inherited from SettableTooltipClient
| SettableTooltipClient ()=default

## Detailed Description

A list of items that can be scrolled vertically.

To create a list, you'll need to create a subclass of ListBoxModel. This can either paint each row of the list and respond to events via callbacks, or for more specialised tasks, it can supply a custom component to fill each row.

See also
  ComboBox, TableListBox

## Member Enumeration Documentation

## ◆ ColourIds

enum ListBox::ColourIds

A set of colour IDs to use to change the colour of various aspects of the label.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour to fill the list with. Make this transparent if you don't want the background to be filled.
outlineColourId | An optional colour to use to draw a border around the list. Make this transparent to not have an outline.
textColourId | The preferred colour to use for drawing text in the listbox.

## Constructor & Destructor Documentation

## ◆ ListBox()

ListBox::ListBox | ( | const String & | componentName = `String()`,
|  | ListBoxModel * | model = `nullptr`
| ) |  |

Creates a ListBox.

The model pointer passed-in can be null, in which case you can set it later with setModel().

The ListBoxModel instance must stay alive for as long as the ListBox holds a pointer to it. Be careful to destroy the ListBox before the ListBoxModel, or to call ListBox::setModel (nullptr) before destroying the ListBoxModel.

## ◆ ~ListBox()

ListBox::~ListBox | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setModel()

void ListBox::setModel | ( | ListBoxModel * | newModel | ) |

Changes the current data model to display.

The ListBoxModel instance must stay alive for as long as the ListBox holds a pointer to it. Be careful to destroy the ListBox before the ListBoxModel, or to call ListBox::setModel (nullptr) before destroying the ListBoxModel.

## ◆ getListBoxModel()

ListBoxModel * ListBox::getListBoxModel | ( |  | ) | const
| noexcept

Returns the current list model.

## ◆ updateContent()

void ListBox::updateContent | ( |  | ) |

Causes the list to refresh its content.

Call this when the number of rows in the list changes, or if you want it to call refreshComponentForRow() on all the row components.

This must only be called from the main message thread.

## ◆ setMultipleSelectionEnabled()

void ListBox::setMultipleSelectionEnabled | ( | bool | shouldBeEnabled | ) |
| noexcept

Turns on multiple-selection of rows.

By default this is disabled.

When your row component gets clicked you'll need to call the selectRowsBasedOnModifierKeys() method to tell the list that it's been clicked and to get it to do the appropriate selection based on whether the ctrl/shift keys are held down.

## ◆ setClickingTogglesRowSelection()

void ListBox::setClickingTogglesRowSelection | ( | bool | flipRowSelection | ) |
| noexcept

If enabled, this makes the listbox flip the selection status of each row that the user clicks, without affecting other selected rows.

(This only has an effect if multiple selection is also enabled). If not enabled, you can still get the same row-flipping behaviour by holding down CMD or CTRL when clicking.

## ◆ setRowSelectedOnMouseDown()

void ListBox::setRowSelectedOnMouseDown | ( | bool | isSelectedOnMouseDown | ) |
| noexcept

Sets whether a row should be selected when the mouse is pressed or released.

By default this is true, but you may want to turn it off.

## ◆ getRowSelectedOnMouseDown()

bool ListBox::getRowSelectedOnMouseDown | ( |  | ) | const

Gets whether a row should be selected when the mouse is pressed or released.

By default this is true, but you may want to turn it off.

## ◆ setMouseMoveSelectsRows()

void ListBox::setMouseMoveSelectsRows | ( | bool | shouldSelect | ) |

Makes the list react to mouse moves by selecting the row that the mouse if over.

This function is here primarily for the ComboBox class to use, but might be useful for some other purpose too.

## ◆ selectRow()

void ListBox::selectRow | ( | int | rowNumber,
|  | bool | dontScrollToShowThisRow = `false`,
|  | bool | deselectOthersFirst = `true`
| ) |  |

Selects a row.

If the row is already selected, this won't do anything.

Parameters

  rowNumber | the row to select
  dontScrollToShowThisRow | if true, the list's position won't change; if false and the selected row is off-screen, it'll scroll to make sure that row is on-screen
  deselectOthersFirst | if true and there are multiple selections, these will first be deselected before this item is selected

See also
  isRowSelected, selectRowsBasedOnModifierKeys, flipRowSelection, deselectRow, deselectAllRows, selectRangeOfRows

## ◆ selectRangeOfRows()

void ListBox::selectRangeOfRows | ( | int | firstRow,
|  | int | lastRow,
|  | bool | dontScrollToShowThisRange = `false`
| ) |  |

Selects a set of rows.

This will add these rows to the current selection, so you might need to clear the current selection first with deselectAllRows()

Parameters

  firstRow | the first row to select (inclusive)
  lastRow | the last row to select (inclusive)
  dontScrollToShowThisRange | if true, the list's position won't change; if false and the selected range is off-screen, it'll scroll to make sure that the range of rows is on-screen

## ◆ deselectRow()

void ListBox::deselectRow | ( | int | rowNumber | ) |

Deselects a row.

If it's not currently selected, this will do nothing.

See also
  selectRow, deselectAllRows

## ◆ deselectAllRows()

void ListBox::deselectAllRows | ( |  | ) |

Deselects any currently selected rows.

See also
  deselectRow

## ◆ flipRowSelection()

void ListBox::flipRowSelection | ( | int | rowNumber | ) |

Selects or deselects a row.

If the row's currently selected, this deselects it, and vice-versa.

## ◆ getSelectedRows()

SparseSet< int > ListBox::getSelectedRows | ( |  | ) | const

Returns a sparse set indicating the rows that are currently selected.

See also
  setSelectedRows

## ◆ setSelectedRows()

void ListBox::setSelectedRows | ( | const SparseSet< int > & | setOfRowsToBeSelected,
|  | NotificationType | sendNotificationEventToModel = `sendNotification`
| ) |  |

Sets the rows that should be selected, based on an explicit set of ranges.

If sendNotificationEventToModel is true, the ListBoxModel::selectedRowsChanged() method will be called. If it's false, no notification will be sent to the model.

See also
  getSelectedRows

## ◆ isRowSelected()

bool ListBox::isRowSelected | ( | int | rowNumber | ) | const

Checks whether a row is selected.

## ◆ getNumSelectedRows()

int ListBox::getNumSelectedRows | ( |  | ) | const

Returns the number of rows that are currently selected.

See also
  getSelectedRow, isRowSelected, getLastRowSelected

## ◆ getSelectedRow()

int ListBox::getSelectedRow | ( | int | index = `0` | ) | const

Returns the row number of a selected row.

This will return the row number of the Nth selected row. The row numbers returned will be sorted in order from low to high.

Parameters

  index | the index of the selected row to return, (from 0 to getNumSelectedRows() - 1)

Returns
  the row number, or -1 if the index was out of range or if there aren't any rows selected

See also
  getNumSelectedRows, isRowSelected, getLastRowSelected

## ◆ getLastRowSelected()

int ListBox::getLastRowSelected | ( |  | ) | const

Returns the last row that the user selected.

This isn't the same as the highest row number that is currently selected - if the user had multiply-selected rows 10, 5 and then 6 in that order, this would return 6.

If nothing is selected, it will return -1.

## ◆ selectRowsBasedOnModifierKeys()

void ListBox::selectRowsBasedOnModifierKeys | ( | int | rowThatWasClickedOn,
|  | ModifierKeys | modifiers,
|  | bool | isMouseUpEvent
| ) |  |

Multiply-selects rows based on the modifier keys.

If no modifier keys are down, this will select the given row and deselect any others.

If the ctrl (or command on the Mac) key is down, it'll flip the state of the selected row.

If the shift key is down, it'll select up to the given row from the last row selected.

See also
  selectRow

## ◆ setVerticalPosition()

void ListBox::setVerticalPosition | ( | double | newProportion | ) |

Scrolls the list to a particular position.

The proportion is between 0 and 1.0, so 0 scrolls to the top of the list, 1.0 scrolls to the bottom.

If the total number of rows all fit onto the screen at once, then this method won't do anything.

See also
  getVerticalPosition

## ◆ getVerticalPosition()

double ListBox::getVerticalPosition | ( |  | ) | const

Returns the current vertical position as a proportion of the total.

This can be used in conjunction with setVerticalPosition() to save and restore the list's position. It returns a value in the range 0 to 1.

See also
  setVerticalPosition

## ◆ scrollToEnsureRowIsOnscreen()

void ListBox::scrollToEnsureRowIsOnscreen | ( | int | row | ) |

Scrolls if necessary to make sure that a particular row is visible.

## ◆ getVerticalScrollBar()

ScrollBar & ListBox::getVerticalScrollBar | ( |  | ) | const
| noexcept

Returns a reference to the vertical scrollbar.

## ◆ getHorizontalScrollBar()

ScrollBar & ListBox::getHorizontalScrollBar | ( |  | ) | const
| noexcept

Returns a reference to the horizontal scrollbar.

## ◆ getRowContainingPosition()

int ListBox::getRowContainingPosition | ( | int | x,
|  | int | y
| ) |  | const
| noexcept

Finds the row index that contains a given x,y position.

The position is relative to the ListBox's top-left. If no row exists at this position, the method will return -1.

See also
  getComponentForRowNumber

## ◆ getInsertionIndexForPosition()

int ListBox::getInsertionIndexForPosition | ( | int | x,
|  | int | y
| ) |  | const
| noexcept

Finds a row index that would be the most suitable place to insert a new item for a given position.

This is useful when the user is e.g. dragging and dropping onto the listbox, because it lets you easily choose the best position to insert the item that they drop, based on where they drop it.

If the position is out of range, this will return -1. If the position is beyond the end of the list, it will return getNumRows() to indicate the end of the list.

See also
  getComponentForRowNumber

## ◆ getRowPosition()

Rectangle< int > ListBox::getRowPosition | ( | int | rowNumber,
|  | bool | relativeToComponentTopLeft
| ) |  | const
| noexcept

Returns the position of one of the rows, relative to the top-left of the listbox.

This may be off-screen, and the range of the row number that is passed-in is not checked to see if it's a valid row.

## ◆ getComponentForRowNumber()

Component * ListBox::getComponentForRowNumber | ( | int | rowNumber | ) | const
| noexcept

Finds the row component for a given row in the list.

The component returned will have been created using ListBoxModel::refreshComponentForRow().

If the component for this row is off-screen or if the row is out-of-range, this will return nullptr.

See also
  getRowContainingPosition

## ◆ getRowNumberOfComponent()

int ListBox::getRowNumberOfComponent | ( | const Component * | rowComponent | ) | const
| noexcept

Returns the row number that the given component represents.

If the component isn't one of the list's rows, this will return -1.

## ◆ getVisibleRowWidth()

int ListBox::getVisibleRowWidth | ( |  | ) | const
| noexcept

Returns the width of a row (which may be less than the width of this component if there's a scrollbar).

## ◆ setRowHeight()

void ListBox::setRowHeight | ( | int | newHeight | ) |

Sets the height of each row in the list.

The default height is 22 pixels.

See also
  getRowHeight

## ◆ getRowHeight()

int ListBox::getRowHeight | ( |  | ) | const
| noexcept

Returns the height of a row in the list.

See also
  setRowHeight

## ◆ getNumRowsOnScreen()

int ListBox::getNumRowsOnScreen | ( |  | ) | const
| noexcept

Returns the number of rows actually visible.

This is the number of whole rows which will fit on-screen, so the value might be more than the actual number of rows in the list.

## ◆ setOutlineThickness()

void ListBox::setOutlineThickness | ( | int | outlineThickness | ) |

Sets the thickness of a border that will be drawn around the box.

To set the colour of the outline, use

setColour (ListBox::outlineColourId, colourXYZ);
Component::setColour
void setColour(int colourID, Colour newColour)
Registers a colour to be used for a particular purpose.
Component::FocusChangeDirection::forward
@ forward
ListBox::outlineColourId
@ outlineColourId
An optional colour to use to draw a border around the list.
Definition juce_ListBox.h:507

See also
  outlineColourId

## ◆ getOutlineThickness()

int ListBox::getOutlineThickness | ( |  | ) | const
| noexcept

Returns the thickness of outline that will be drawn around the listbox.

See also
  setOutlineColour

## ◆ setHeaderComponent()

void ListBox::setHeaderComponent | ( | std::unique_ptr< Component > | newHeaderComponent | ) |

Sets a component that the list should use as a header.

This will position the given component at the top of the list, maintaining the height of the component passed-in, but rescaling it horizontally to match the width of the items in the listbox.

The component will be deleted when setHeaderComponent() is called with a different component, or when the listbox is deleted.

## ◆ getHeaderComponent()

Component * ListBox::getHeaderComponent | ( |  | ) | const
| noexcept

Returns whatever header component was set with setHeaderComponent().

## ◆ setMinimumContentWidth()

void ListBox::setMinimumContentWidth | ( | int | newMinimumWidth | ) |

Changes the width of the rows in the list.

This can be used to make the list's row components wider than the list itself - the width of the rows will be either the width of the list or this value, whichever is greater, and if the rows become wider than the list, a horizontal scrollbar will appear.

The default value for this is 0, which means that the rows will always be the same width as the list.

## ◆ getVisibleContentWidth()

int ListBox::getVisibleContentWidth | ( |  | ) | const
| noexcept

Returns the space currently available for the row items, taking into account borders, scrollbars, etc.

## ◆ repaintRow()

void ListBox::repaintRow | ( | int | rowNumber | ) |
| noexcept

Repaints one of the rows.

This does not invoke updateContent(), it just invokes a straightforward repaint for the area covered by this row.

## ◆ createSnapshotOfRows()

virtual ScaledImage ListBox::createSnapshotOfRows | ( | const SparseSet< int > & | rows,
|  | int & | x,
|  | int & | y
| ) |  |
| virtual

This fairly obscure method creates an image that shows the row components specified in rows (for example, these could be the currently selected row components).

It's a handy method for doing drag-and-drop, as it can be passed to the DragAndDropContainer for use as the drag image.

Note that it will make the row components temporarily invisible, so if you're using custom components this could affect them if they're sensitive to that sort of thing.

See also
  Component::createComponentSnapshot

## ◆ getViewport()

Viewport * ListBox::getViewport | ( |  | ) | const
| noexcept

Returns the viewport that this ListBox uses.

You may need to use this to change parameters such as whether scrollbars are shown, etc.

## ◆ keyPressed()

bool ListBox::keyPressed | ( | const KeyPress & | key | ) |
| overridevirtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from Component.

## ◆ keyStateChanged()

bool ListBox::keyStateChanged | ( | bool | isKeyDown | ) |
| overridevirtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from Component.

## ◆ paint()

void ListBox::paint | ( | Graphics & | g | ) |
| overridevirtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from Component.

## ◆ paintOverChildren()

void ListBox::paintOverChildren | ( | Graphics & | g | ) |
| overridevirtual

Components can override this method to draw over the top of their children.

For most drawing operations, it's better to use the normal paint() method, but if you need to overlay something on top of the children, this can be used.

See also
  paint, Graphics

Reimplemented from Component.

## ◆ resized()

void ListBox::resized | ( |  | ) |
| overridevirtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from Component.

Reimplemented in TableListBox.

## ◆ visibilityChanged()

void ListBox::visibilityChanged | ( |  | ) |
| overridevirtual

Called when this component's visibility changes.

See also
  setVisible, isVisible

Reimplemented from Component.

## ◆ mouseWheelMove()

void ListBox::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel
| ) |  |
| overridevirtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them. (Bear in mind that if you attach a component as a mouse-listener to other components, then those wheel moves will also end up calling this method and being passed up to the parents, which may not be what you intended to happen).

Parameters

  event | details about the mouse event
  wheel | details about the mouse wheel movement

Reimplemented from Component.

## ◆ mouseUp()

void ListBox::mouseUp | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from Component.

## ◆ colourChanged()

void ListBox::colourChanged | ( |  | ) |
| overridevirtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChanged() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChanged

Reimplemented from Component.

## ◆ parentHierarchyChanged()

void ListBox::parentHierarchyChanged | ( |  | ) |
| overridevirtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, this method will be called on all of its children (recursively - so all children of its children will also be called as well).

Subclasses can override this if they need to react to this in some way.

See also
  getParentComponent, isShowing, ComponentListener::componentParentHierarchyChanged

Reimplemented from Component.

## ◆ startDragAndDrop()

void ListBox::startDragAndDrop | ( | const MouseEvent & | ,
|  | const SparseSet< int > & | rowsToDrag,
|  | const var & | dragDescription,
|  | bool | allowDraggingToOtherWindows
| ) |  |

## ◆ createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > ListBox::createAccessibilityHandler | ( |  | ) |
| overridevirtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from Component.

Reimplemented in TableListBox.

## ◆ getModel()

ListBoxModel * ListBox::getModel | ( |  | ) | const
| noexcept

The documentation for this class was generated from the following file:

- juce_ListBox.h